diff --git a/gdb/testsuite/ChangeLog b/gdb/testsuite/ChangeLog
index 83261df..aa1d6b8 100644
--- a/gdb/testsuite/ChangeLog
+++ b/gdb/testsuite/ChangeLog
@@ -1,5 +1,18 @@
 2017-08-28  Simon Marchi  <simon.marchi@ericsson.com>
 
+	* gdb.base/commands.exp (gdbvar_simple_if_test,
+	gdbvar_simple_if_test, gdbvar_complex_if_while_test,
+	progvar_simple_if_test, progvar_simple_while_test,
+	progvar_complex_if_while_test, user_defined_command_test,
+	user_defined_command_args_eval,
+	user_defined_command_args_stack_test,
+	user_defined_command_manyargs_test, bp_deleted_in_command_test,
+	temporary_breakpoint_commands,
+	gdb_test_no_prompt, redefine_hook_test,
+	redefine_backtrace_test): Remove "global gdb_prompt".
+
+2017-08-28  Simon Marchi  <simon.marchi@ericsson.com>
+
 	* gdb.base/commands.exp (user_defined_command_case_sensitivity):
 	New proc, call it from toplevel.
 
diff --git a/gdb/testsuite/gdb.base/commands.exp b/gdb/testsuite/gdb.base/commands.exp
index 4cd5f46..c934052 100644
--- a/gdb/testsuite/gdb.base/commands.exp
+++ b/gdb/testsuite/gdb.base/commands.exp
@@ -34,7 +34,6 @@ proc runto_or_return {function} {
 }
 
 proc_with_prefix gdbvar_simple_if_test {} {
-    global gdb_prompt
     global valnum_re
 
     gdb_test_no_output "set \$foo = 0" "set foo"
@@ -62,7 +61,6 @@ proc_with_prefix gdbvar_simple_if_test {} {
 }
 
 proc_with_prefix gdbvar_simple_while_test {} {
-    global gdb_prompt
     global valnum_re
 
     gdb_test_no_output "set \$foo = 5" "set foo"
@@ -83,7 +81,6 @@ proc_with_prefix gdbvar_simple_while_test {} {
 }
 
 proc_with_prefix gdbvar_complex_if_while_test {} {
-    global gdb_prompt
     global valnum_re
 
     gdb_test_no_output "set \$foo = 4" "set foo"
@@ -107,7 +104,6 @@ proc_with_prefix gdbvar_complex_if_while_test {} {
 }
 
 proc_with_prefix progvar_simple_if_test {} {
-    global gdb_prompt
     global valnum_re
 
     runto_or_return factorial
@@ -139,7 +135,6 @@ proc_with_prefix progvar_simple_if_test {} {
 }
 
 proc_with_prefix progvar_simple_while_test {} {
-    global gdb_prompt
     global valnum_re
 
     runto_or_return factorial
@@ -164,7 +159,6 @@ proc_with_prefix progvar_simple_while_test {} {
 }
 
 proc_with_prefix progvar_complex_if_while_test {} {
-    global gdb_prompt
     global valnum_re
 
     runto_or_return factorial
@@ -289,7 +283,6 @@ proc_with_prefix breakpoint_command_test {} {
 
 # Test a simple user defined command (with arguments)
 proc_with_prefix user_defined_command_test {} {
-    global gdb_prompt
     global valnum_re
 
     gdb_test_no_output "set \$foo = 4" "set foo"
@@ -384,8 +377,6 @@ proc_with_prefix user_defined_command_case_sensitivity {} {
 # Test that "eval" in a user-defined command expands $argc/$argN.
 
 proc_with_prefix user_defined_command_args_eval {} {
-    global gdb_prompt
-
     gdb_test_multiple "define command_args_eval" \
 	"define command_args_eval" {
 	    -re "End with"  {
@@ -416,8 +407,6 @@ proc_with_prefix user_defined_command_args_eval {} {
 # user-defined command (or in this case, recurses).
 
 proc_with_prefix user_defined_command_args_stack_test {} {
-    global gdb_prompt
-
     gdb_test_multiple "define args_stack_command" \
 	"define args_stack_command" {
 	    -re "End with"  {
@@ -473,8 +462,6 @@ proc_with_prefix user_defined_command_args_stack_test {} {
 # used to have a hard coded limit of 10 arguments.
 
 proc_with_prefix user_defined_command_manyargs_test {} {
-    global gdb_prompt
-
     set test "define command"
     gdb_test_multiple "define manyargs" $test {
 	-re "End with"  {
@@ -707,8 +694,6 @@ proc_with_prefix bp_deleted_in_command_test {} {
 }
 
 proc_with_prefix temporary_breakpoint_commands {} {
-    global gdb_prompt
-
     delete_breakpoints
 
     # Create a temporary breakpoint, and associate a commands list to it.
@@ -824,8 +809,6 @@ end"
 }
 
 proc gdb_test_no_prompt { command result msg } {
-    global gdb_prompt
-
     set msg "$command - $msg"
     set result "^[string_to_regexp $command]\r\n$result$"
     gdb_test_multiple $command $msg {
@@ -972,8 +955,6 @@ proc_with_prefix error_clears_commands_left {} {
 }
 
 proc_with_prefix redefine_hook_test {} {
-    global gdb_prompt
-
     gdb_test \
 	[multi_line_input \
 	     "define one"\
@@ -1007,8 +988,6 @@ proc_with_prefix redefine_hook_test {} {
 }
 
 proc_with_prefix redefine_backtrace_test {} {
-    global gdb_prompt
-
     gdb_test_multiple "define backtrace" "define backtrace" {
 	-re "Really redefine built-in command \"backtrace\"\\? \\(y or n\\) $"  {
 	    pass "define backtrace"