diff --git a/gdb/testsuite/ChangeLog b/gdb/testsuite/ChangeLog
index baa0553..c1fe2d0 100644
--- a/gdb/testsuite/ChangeLog
+++ b/gdb/testsuite/ChangeLog
@@ -1,3 +1,34 @@
+2019-10-31  Tom de Vries  <tdevries@suse.de>
+
+	* gdb.ada/array_bounds.exp: Drop superfluous 3rd argument to gdb_test.
+	* gdb.ada/array_subscript_addr.exp: Same.
+	* gdb.ada/arrayidx.exp: Same.
+	* gdb.ada/arrayparam.exp: Same.
+	* gdb.ada/arrayptr.exp: Same.
+	* gdb.ada/boolean_expr.exp: Same.
+	* gdb.ada/call_pn.exp: Same.
+	* gdb.ada/complete.exp: Same.
+	* gdb.ada/fixed_cmp.exp: Same.
+	* gdb.ada/fun_addr.exp: Same.
+	* gdb.ada/funcall_param.exp: Same.
+	* gdb.ada/interface.exp: Same.
+	* gdb.ada/mod_from_name.exp: Same.
+	* gdb.ada/null_array.exp: Same.
+	* gdb.ada/packed_array.exp: Same.
+	* gdb.ada/packed_tagged.exp: Same.
+	* gdb.ada/print_chars.exp: Same.
+	* gdb.ada/print_pc.exp: Same.
+	* gdb.ada/ptype_arith_binop.exp: Same.
+	* gdb.ada/ptype_field.exp: Same.
+	* gdb.ada/ptype_tagged_param.exp: Same.
+	* gdb.ada/rec_return.exp: Same.
+	* gdb.ada/ref_tick_size.exp: Same.
+	* gdb.ada/str_ref_cmp.exp: Same.
+	* gdb.ada/taft_type.exp: Same.
+	* gdb.ada/tagged.exp: Same.
+	* gdb.ada/type_coercion.exp: Same.
+	* gdb.ada/uninitialized_vars.exp: Same.
+
 2019-10-30  Tom de Vries  <tdevries@suse.de>
 
 	* lib/gdb.exp (gdb_test_multiple): Handle -early pattern flag.
diff --git a/gdb/testsuite/gdb.ada/array_bounds.exp b/gdb/testsuite/gdb.ada/array_bounds.exp
index c35488f..fea22d6 100644
--- a/gdb/testsuite/gdb.ada/array_bounds.exp
+++ b/gdb/testsuite/gdb.ada/array_bounds.exp
@@ -30,18 +30,13 @@
 } 
 
 gdb_test "print itable'first" \
-         "= 2" \
-         "print itable'first"
+         "= 2"
 
 gdb_test "print itable'last" \
-         "= 5" \
-         "print itable'last"
+         "= 5"
 
 gdb_test "print table'first" \
-         "= zero" \
-         "print table'first"
+         "= zero"
 
 gdb_test "print table'last" \
-         "= two" \
-         "print table'last"
-
+         "= two"
diff --git a/gdb/testsuite/gdb.ada/array_subscript_addr.exp b/gdb/testsuite/gdb.ada/array_subscript_addr.exp
index c754c0e..581564a 100644
--- a/gdb/testsuite/gdb.ada/array_subscript_addr.exp
+++ b/gdb/testsuite/gdb.ada/array_subscript_addr.exp
@@ -29,6 +29,4 @@
 # Verify that we can compare a string slice with another string.
 
 gdb_test "print a(2)'Address" \
-         "= \\(system\\.address\\) 0x\[0-9a-fA-F\]+" \
-         "print a(2)'Address"
-
+         "= \\(system\\.address\\) 0x\[0-9a-fA-F\]+"
diff --git a/gdb/testsuite/gdb.ada/arrayidx.exp b/gdb/testsuite/gdb.ada/arrayidx.exp
index 9044da5..8805e17 100644
--- a/gdb/testsuite/gdb.ada/arrayidx.exp
+++ b/gdb/testsuite/gdb.ada/arrayidx.exp
@@ -90,44 +90,34 @@
     setup_xfail "*-*-*"
 }
 gdb_test "print one_two_three" \
-         "= \\(1 => 1, 2 => 2, 3 => 3\\)" \
-         "print one_two_three"
+         "= \\(1 => 1, 2 => 2, 3 => 3\\)"
 
 gdb_test "print e_one_two_three" \
-         "= \\(one => 1, two => 2, three => 3\\)" \
-         "print e_one_two_three"
+         "= \\(one => 1, two => 2, three => 3\\)"
 
 gdb_test "print r_two_three" \
-         "= \\(two => 2, three => 3\\)" \
-         "print r_two_three"
+         "= \\(two => 2, three => 3\\)"
 
 gdb_test "print u_one_two_three" \
-         "= \\(1 => 1, 2 => 2, 3 => 3\\)" \
-         "print u_one_two_three"
+         "= \\(1 => 1, 2 => 2, 3 => 3\\)"
 
 gdb_test "print p_one_two_three" \
-         "= \\(one => false, two => true, three => true\\)" \
-         "print p_one_two_three"
+         "= \\(one => false, two => true, three => true\\)"
 
 if $old_gcc {
     setup_xfail "*-*-*"
 }
 gdb_test "print few_reps" \
-         "= \\(1 => 1, 2 => 2, 3 => 3, 4 => 3, 5 => 3, 6 => 3, 7 => 3, 8 => 4, 9 => 5\\)" \
-         "print few_reps"
+         "= \\(1 => 1, 2 => 2, 3 => 3, 4 => 3, 5 => 3, 6 => 3, 7 => 3, 8 => 4, 9 => 5\\)"
 
 if $old_gcc {
     setup_xfail "*-*-*"
 }
 gdb_test "print many_reps" \
-         "= \\(1 => 1, 2 => 2, 3 => 3 <repeats 12 times>, 15 => 4, 16 => 5\\)" \
-         "print many_reps"
+         "= \\(1 => 1, 2 => 2, 3 => 3 <repeats 12 times>, 15 => 4, 16 => 5\\)"
 
 if $old_gcc {
     setup_xfail "*-*-*"
 }
 gdb_test "print empty" \
-         "= \\(\\)" \
-         "print empty"
-
-
+         "= \\(\\)"
diff --git a/gdb/testsuite/gdb.ada/arrayparam.exp b/gdb/testsuite/gdb.ada/arrayparam.exp
index a241c44..adc9b4e 100644
--- a/gdb/testsuite/gdb.ada/arrayparam.exp
+++ b/gdb/testsuite/gdb.ada/arrayparam.exp
@@ -30,8 +30,7 @@
 # works without problem.
 
 gdb_test "print call_me (\"bonjour\")" \
-         "= void" \
-         "print call_me (\"bonjour\")"
+         "= void"
 
 # Verify that the array was passed properly by checking the global
 # variables that Call_Me sets as side-effects.  Use the package name to avoid
diff --git a/gdb/testsuite/gdb.ada/arrayptr.exp b/gdb/testsuite/gdb.ada/arrayptr.exp
index eb0890a..e12ed08 100644
--- a/gdb/testsuite/gdb.ada/arrayptr.exp
+++ b/gdb/testsuite/gdb.ada/arrayptr.exp
@@ -30,8 +30,7 @@
 } 
 
 gdb_test "print string_p" \
-         "= \\(foo\\.string_access\\) 0x\[0-9a-zA-Z\]+" \
-         "print string_p"
+         "= \\(foo\\.string_access\\) 0x\[0-9a-zA-Z\]+"
 
 gdb_test "print string_p (3..4)" "= \"ll\""
 
diff --git a/gdb/testsuite/gdb.ada/boolean_expr.exp b/gdb/testsuite/gdb.ada/boolean_expr.exp
index 3308c29..067c7e4 100644
--- a/gdb/testsuite/gdb.ada/boolean_expr.exp
+++ b/gdb/testsuite/gdb.ada/boolean_expr.exp
@@ -28,10 +28,7 @@
          "changing the language to ada"
 
 gdb_test "print 1 = 2" \
-         "= false" \
-         "print 1 = 2"
+         "= false"
 
 gdb_test "print 3 = 3" \
-         "= true" \
-         "print 3 = 3"
-
+         "= true"
diff --git a/gdb/testsuite/gdb.ada/call_pn.exp b/gdb/testsuite/gdb.ada/call_pn.exp
index 056fe07..6eb33b6 100644
--- a/gdb/testsuite/gdb.ada/call_pn.exp
+++ b/gdb/testsuite/gdb.ada/call_pn.exp
@@ -35,7 +35,7 @@
 # Now, call procedure Pn, which should set Last_Node_Id to the value
 # of the parameter used in the function call.  Verify that we can print
 # the returned value correctly, while we're at it.
-gdb_test "print pn (4321)" "= 4321" "print pn (4321)"
+gdb_test "print pn (4321)" "= 4321"
 
 # Make sure that last_node_id now has the correct value...
 gdb_test "print last_node_id" "= 4321" "print last_node_id after calling pn"
diff --git a/gdb/testsuite/gdb.ada/complete.exp b/gdb/testsuite/gdb.ada/complete.exp
index 1746c18..77a7774 100644
--- a/gdb/testsuite/gdb.ada/complete.exp
+++ b/gdb/testsuite/gdb.ada/complete.exp
@@ -33,8 +33,7 @@
 
 proc test_gdb_complete { expr expected_output } {
     gdb_test "complete p $expr" \
-             "$expected_output" \
-             "complete p $expr"
+             "$expected_output"
 }
 
 # A convenience function that verifies that the "complete EXPR" command
diff --git a/gdb/testsuite/gdb.ada/fixed_cmp.exp b/gdb/testsuite/gdb.ada/fixed_cmp.exp
index feb220c..4c8e3bd 100644
--- a/gdb/testsuite/gdb.ada/fixed_cmp.exp
+++ b/gdb/testsuite/gdb.ada/fixed_cmp.exp
@@ -27,20 +27,15 @@
 runto "fixed.adb:$bp_location"
 
 gdb_test "print My_Var > 10.0" \
-         "= true" \
-         "print My_Var > 10.0"
+         "= true"
 
 gdb_test "print My_Var > 20.0" \
-         "= false" \
-         "print My_Var > 20.0"
+         "= false"
 
 # Do the same, but with integer values.
 
 gdb_test "print My_Var > 10" \
-         "= true" \
-         "print My_Var > 10"
+         "= true"
 
 gdb_test "print My_Var > 20" \
-         "= false" \
-         "print My_Var > 20"
-
+         "= false"
diff --git a/gdb/testsuite/gdb.ada/fun_addr.exp b/gdb/testsuite/gdb.ada/fun_addr.exp
index 70feea0..e5ac090 100644
--- a/gdb/testsuite/gdb.ada/fun_addr.exp
+++ b/gdb/testsuite/gdb.ada/fun_addr.exp
@@ -27,7 +27,4 @@
 # the inferior is *not* running (no frame).
 
 gdb_test "print foo'address" \
-         "= .* 0x\[0-9a-zA-Z\]+ <foo>" \
-         "print foo'address"
-
-
+         "= .* 0x\[0-9a-zA-Z\]+ <foo>"
diff --git a/gdb/testsuite/gdb.ada/funcall_param.exp b/gdb/testsuite/gdb.ada/funcall_param.exp
index 87f7255..b149ea6 100644
--- a/gdb/testsuite/gdb.ada/funcall_param.exp
+++ b/gdb/testsuite/gdb.ada/funcall_param.exp
@@ -30,6 +30,4 @@
 # class-wide.
 
 gdb_test "p ident (ident (my_parameter))" \
-         "= \\(one => 1, two => 2, three => 3\\)" \
-         "p ident (ident (my_parameter))"
-
+         "= \\(one => 1, two => 2, three => 3\\)"
diff --git a/gdb/testsuite/gdb.ada/interface.exp b/gdb/testsuite/gdb.ada/interface.exp
index 3df54b0..02580a3 100644
--- a/gdb/testsuite/gdb.ada/interface.exp
+++ b/gdb/testsuite/gdb.ada/interface.exp
@@ -27,11 +27,7 @@
 runto "foo.adb:$bp_location"
 
 gdb_test "print r" \
-         "= \\(x => 1, y => 2, w => 3, h => 4\\)" \
-         "print r"
+         "= \\(x => 1, y => 2, w => 3, h => 4\\)"
 
 gdb_test "print s" \
-         "= \\(x => 1, y => 2, w => 3, h => 4\\)" \
-         "print s"
-
-
+         "= \\(x => 1, y => 2, w => 3, h => 4\\)"
diff --git a/gdb/testsuite/gdb.ada/mod_from_name.exp b/gdb/testsuite/gdb.ada/mod_from_name.exp
index f2b707f..7f65776 100644
--- a/gdb/testsuite/gdb.ada/mod_from_name.exp
+++ b/gdb/testsuite/gdb.ada/mod_from_name.exp
@@ -30,7 +30,4 @@
 } 
 
 gdb_test "print xp" \
-         "= \\(y => \\(-1, -2, -3, -4, -5, -6, -7, -8, -9, -10\\)\\)" \
-         "print xp"
-
-
+         "= \\(y => \\(-1, -2, -3, -4, -5, -6, -7, -8, -9, -10\\)\\)"
diff --git a/gdb/testsuite/gdb.ada/null_array.exp b/gdb/testsuite/gdb.ada/null_array.exp
index de43b35..1ad11ca 100644
--- a/gdb/testsuite/gdb.ada/null_array.exp
+++ b/gdb/testsuite/gdb.ada/null_array.exp
@@ -36,13 +36,10 @@
     setup_xfail *-*-* 
 }
 gdb_test "print my_table" \
-         "= \\(\\)" \
-         "print my_table"
+         "= \\(\\)"
 
 gdb_test "ptype my_table" \
-         "type = array \\(10 \\.\\. 1\\) of integer" \
-         "ptype my_table"
+         "type = array \\(10 \\.\\. 1\\) of integer"
 
 gdb_test "print my_matrix" \
-         "= \\(m => \\((\"\", ){9}\"\"\\)\\)" \
-         "print my_matrix"
+         "= \\(m => \\((\"\", ){9}\"\"\\)\\)"
diff --git a/gdb/testsuite/gdb.ada/packed_array.exp b/gdb/testsuite/gdb.ada/packed_array.exp
index 7ad9d77..21f6cad 100644
--- a/gdb/testsuite/gdb.ada/packed_array.exp
+++ b/gdb/testsuite/gdb.ada/packed_array.exp
@@ -29,19 +29,16 @@
 runto "pa.adb:$bp_location"
 
 gdb_test "print var" \
-         "= \\(4 => true, false, true, false, true\\)" \
-         "print var"
+         "= \\(4 => true, false, true, false, true\\)"
 
 # Try printing the value and the type definition of a reference
 # to variable "Var".
 
 gdb_test "ptype &var" \
-         "type = access array \\(4 \\.\\. 8\\) of boolean <packed: 1-bit elements>" \
-         "ptype &var"
+         "type = access array \\(4 \\.\\. 8\\) of boolean <packed: 1-bit elements>"
 
 gdb_test "print &var" \
-         "= \\(access pa.packed_array\\) 0x.*" \
-         "print &var"
+         "= \\(access pa.packed_array\\) 0x.*"
 
 # Print the value of U_Var, an unconstrainted packed array.
 
diff --git a/gdb/testsuite/gdb.ada/packed_tagged.exp b/gdb/testsuite/gdb.ada/packed_tagged.exp
index 9430e08..70b99b7 100644
--- a/gdb/testsuite/gdb.ada/packed_tagged.exp
+++ b/gdb/testsuite/gdb.ada/packed_tagged.exp
@@ -27,8 +27,7 @@
 runto "comp_bug.adb:$bp_location"
 
 gdb_test "print x" \
-         "= \\(exists => true, value => 10\\)" \
-         "print x"
+         "= \\(exists => true, value => 10\\)"
 
 gdb_test "ptype x" \
          [multi_line "type = record" \
@@ -38,6 +37,4 @@
                      "            value: range 0 \\.\\. 255;" \
                      "        when others => null;" \
                      "    end case;" \
-                     "end record" ] \
-         "ptype x"
-
+                     "end record" ]
diff --git a/gdb/testsuite/gdb.ada/print_chars.exp b/gdb/testsuite/gdb.ada/print_chars.exp
index 9a0e215..85877fc 100644
--- a/gdb/testsuite/gdb.ada/print_chars.exp
+++ b/gdb/testsuite/gdb.ada/print_chars.exp
@@ -28,15 +28,12 @@
 
 
 gdb_test "print C" \
-         "= 97 'a'"  \
-         "print C"
+         "= 97 'a'"
 
 gdb_test "print WC" \
-         "= 98 'b'"  \
-         "print WC"
+         "= 98 'b'"
 
 gdb_test "print WWC" \
-         "= 99 'c'"  \
-         "print WWC"
+         "= 99 'c'"
 
 gdb_test "print MC" " = 77 'M'"
diff --git a/gdb/testsuite/gdb.ada/print_pc.exp b/gdb/testsuite/gdb.ada/print_pc.exp
index 85502db..99f0a34 100644
--- a/gdb/testsuite/gdb.ada/print_pc.exp
+++ b/gdb/testsuite/gdb.ada/print_pc.exp
@@ -27,5 +27,4 @@
 runto "dummy.adb:$bp_location"
 
 gdb_test "p /x \$pc" \
-         "= 0x\[0-9a-zA-Z\]+" \
-         "p /x \$pc"
+         "= 0x\[0-9a-zA-Z\]+"
diff --git a/gdb/testsuite/gdb.ada/ptype_arith_binop.exp b/gdb/testsuite/gdb.ada/ptype_arith_binop.exp
index 53e232f..423b91b 100644
--- a/gdb/testsuite/gdb.ada/ptype_arith_binop.exp
+++ b/gdb/testsuite/gdb.ada/ptype_arith_binop.exp
@@ -21,11 +21,7 @@
          "set lang ada"
 
 gdb_test "ptype 3 * 2.0" \
-         "= <\[0-9\]+-byte float>" \
-         "ptype 3 * 2.0"
+         "= <\[0-9\]+-byte float>"
 
 gdb_test "ptype 3 / 2.0" \
-         "= <\[0-9\]+-byte float>" \
-         "ptype 3 / 2.0"
-
-
+         "= <\[0-9\]+-byte float>"
diff --git a/gdb/testsuite/gdb.ada/ptype_field.exp b/gdb/testsuite/gdb.ada/ptype_field.exp
index eae5c62..05d09ed 100644
--- a/gdb/testsuite/gdb.ada/ptype_field.exp
+++ b/gdb/testsuite/gdb.ada/ptype_field.exp
@@ -30,19 +30,13 @@
          [multi_line "type = record" \
                      "    pos: pck\\.position;" \
                      "    radius: integer;" \
-                     "end record" ] \
-         "ptype circle"
+                     "end record" ]
 
 gdb_test "ptype circle.pos" \
          [multi_line "type = record" \
                      "    x: integer;" \
                      "    y: integer;" \
-                     "end record" ] \
-         "ptype circle.pos"
+                     "end record" ]
 
 gdb_test "ptype circle.pos.x" \
-         "type = <\[0-9\]+-byte integer>" \
-         "ptype circle.pos.x"
-
-
-
+         "type = <\[0-9\]+-byte integer>"
diff --git a/gdb/testsuite/gdb.ada/ptype_tagged_param.exp b/gdb/testsuite/gdb.ada/ptype_tagged_param.exp
index 976e943..567ef82 100644
--- a/gdb/testsuite/gdb.ada/ptype_tagged_param.exp
+++ b/gdb/testsuite/gdb.ada/ptype_tagged_param.exp
@@ -31,6 +31,4 @@
 set sp "\[ \t\]*"
 
 gdb_test "ptype s" \
-         "type = <ref> new pck.shape with record${eol}${sp}r: integer;${eol}end record" \
-         "ptype s"
-
+         "type = <ref> new pck.shape with record${eol}${sp}r: integer;${eol}end record"
diff --git a/gdb/testsuite/gdb.ada/rec_return.exp b/gdb/testsuite/gdb.ada/rec_return.exp
index ea9345a..69992e6 100644
--- a/gdb/testsuite/gdb.ada/rec_return.exp
+++ b/gdb/testsuite/gdb.ada/rec_return.exp
@@ -30,6 +30,4 @@
 }
 
 gdb_test "print bar" \
-         "= \\(x => 42, s => \"ABCDEFGH\"\\)" \
-         "print bar"
-
+         "= \\(x => 42, s => \"ABCDEFGH\"\\)"
diff --git a/gdb/testsuite/gdb.ada/ref_tick_size.exp b/gdb/testsuite/gdb.ada/ref_tick_size.exp
index 9dbfcd1..3f295c5 100644
--- a/gdb/testsuite/gdb.ada/ref_tick_size.exp
+++ b/gdb/testsuite/gdb.ada/ref_tick_size.exp
@@ -32,6 +32,4 @@
 # the size of d1.
 
 gdb_test "print d1'size = d2'size" \
-         "= true" \
-         "print d1'size = d2'size"
-
+         "= true"
diff --git a/gdb/testsuite/gdb.ada/str_ref_cmp.exp b/gdb/testsuite/gdb.ada/str_ref_cmp.exp
index ede5eb3..e5327f8 100644
--- a/gdb/testsuite/gdb.ada/str_ref_cmp.exp
+++ b/gdb/testsuite/gdb.ada/str_ref_cmp.exp
@@ -42,10 +42,7 @@
 # Verify that we can compare a string slice with another string.
 
 gdb_test "print String_Var (1 .. 3) = \"Hel\"" \
-         "= true" \
-         "print String_Var (1 .. 3) = \"Hel\""
+         "= true"
 
 gdb_test "print String_Var (1 .. 3) = \"hel\"" \
-         "= false" \
-         "print String_Var (1 .. 3) = \"hel\""
-
+         "= false"
diff --git a/gdb/testsuite/gdb.ada/taft_type.exp b/gdb/testsuite/gdb.ada/taft_type.exp
index 654f3c8..b03e200 100644
--- a/gdb/testsuite/gdb.ada/taft_type.exp
+++ b/gdb/testsuite/gdb.ada/taft_type.exp
@@ -30,6 +30,4 @@
 } 
 
 gdb_test "print w.e.all" \
-         "= \\(month => 8, year => 1974\\)" \
-         "print w.e.all"
-
+         "= \\(month => 8, year => 1974\\)"
diff --git a/gdb/testsuite/gdb.ada/tagged.exp b/gdb/testsuite/gdb.ada/tagged.exp
index b8af41d..2c5983d 100644
--- a/gdb/testsuite/gdb.ada/tagged.exp
+++ b/gdb/testsuite/gdb.ada/tagged.exp
@@ -32,23 +32,17 @@
 gdb_test "ptype segm" \
          [multi_line "type = new pck\\.object with record" \
                      "    width: integer;" \
-                     "end record" ] \
-         "ptype segm"
+                     "end record" ]
 
 gdb_test "print segm" \
-         "= \\(position => 74, width => 8\\)" \
-         "print segm"
+         "= \\(position => 74, width => 8\\)"
 
 # Now, test printing of an class-wide object.
 
 gdb_test "ptype obj" \
          [multi_line "type = new pck\\.object with record" \
                      "    width: integer;" \
-                     "end record" ] \
-         "ptype obj"
+                     "end record" ]
 
 gdb_test "print obj" \
-         "= \\(position => 74, width => 8\\)" \
-         "print obj"
-
-
+         "= \\(position => 74, width => 8\\)"
diff --git a/gdb/testsuite/gdb.ada/type_coercion.exp b/gdb/testsuite/gdb.ada/type_coercion.exp
index cdd9423..b411b6b 100644
--- a/gdb/testsuite/gdb.ada/type_coercion.exp
+++ b/gdb/testsuite/gdb.ada/type_coercion.exp
@@ -27,8 +27,7 @@
 runto "assign.adb:$bp_location"
 
 gdb_test "p q" \
-         "= \\(2, 3, 5, 7, 11\\)" \
-         "p q"
+         "= \\(2, 3, 5, 7, 11\\)"
 
 gdb_test_no_output "set \$addr := q'address" \
          "save q'address in convenience variable"
@@ -43,8 +42,4 @@
          "set {Integer} \$addr := 19"
 
 gdb_test "p q" \
-         "= \\(19, 3, 5, 7, 11\\)" \
-         "p q"
-
-
-
+         "= \\(19, 3, 5, 7, 11\\)"
diff --git a/gdb/testsuite/gdb.ada/uninitialized_vars.exp b/gdb/testsuite/gdb.ada/uninitialized_vars.exp
index 109b36d..c374c39 100644
--- a/gdb/testsuite/gdb.ada/uninitialized_vars.exp
+++ b/gdb/testsuite/gdb.ada/uninitialized_vars.exp
@@ -33,5 +33,4 @@
 
 # Check that printing uninitialized variables does not crash the debugger.
 gdb_test "info locals" \
-         ".*" \
-         "info locals"
+         ".*"